"""
############################################################################################################
#############################                     EPSILON                      #############################
#############################                   PIV Plugin                     #############################
#############################             Request for information              #############################
############################################################################################################

This script detects the amount of instantaneous PIV files in order to provide information to Paraview to
properly animate the data.

"""


import glob
import os

File_Path = str(File_Path_PIV1)  															    # File path to the data


if File_Path=="":
	timeSteps = range(1)
else:
	Folder_Path=os.path.dirname(File_Path_PIV1)
	if File_Path.endswith('.dat'):
		File_Path = Folder_Path + "\\*.dat"														
	if File_Path.endswith('.csv'):
		File_Path = Folder_Path + "\\*.csv"
			
	FileData = glob.glob(File_Path)
	timeSteps = range(len(FileData))  															# Detects the amount of files of the file sequence in order to define the timestep of the Paraview animation
 
timeRange = [timeSteps[0], timeSteps[-1]]

outInfo = self.GetOutputInformation(0)
outInfo.Set(vtk.vtkStreamingDemandDrivenPipeline.TIME_RANGE(), timeRange, 2)
outInfo.Set(vtk.vtkStreamingDemandDrivenPipeline.TIME_STEPS(), timeSteps, len(timeSteps))




