"""
############################################################################################################
#############################                     EPSILON                      #############################
#############################                Wake Survey Plugin                #############################
#############################             Check Needs Update Script            #############################
############################################################################################################

This script uses a time condition to update (re-execute) Epsilon_Wake_Survey every N-seconds. This is required
for updating the visualization of five-hole probe data during the wind tunnel run (real-time visualization).

"""


import time

# Input parameters are defined as string in Paraview GUI, thus a string to float convertion is required:
UpdateTimeInterval = float(UpdateTimeInterval)   

if not hasattr(self, "_my_time"):
  setattr(self, "_my_time", time.time())

t = time.time()
lastTime = getattr(self, "_my_time")
# adapt here to set the time (in sec) you want to wait between updates
if t - lastTime > UpdateTimeInterval:
  setattr(self, "_my_time", t)
  self.SetNeedsUpdate(True)