# -*- coding: utf-8 -*-
"""
############################################################################################################
#############################                     EPSILON                      #############################
#############################            PIV Dantec Tecplot reader             #############################
############################################################################################################

# Abstract:
This python code is a module of the "Epsilon PIV" plugin that changes the headers of the Tecplot file from Dantec.


# Disclaimer:
This plugin was developed for research purposes and released under GNU GPL V3 license without any guarantee
of any kind, either express or implied. Its use for teaching, research and industrial applications is allowed
under the strict responsibility of the user. The authors of this plugin are not responsible for any damages
or errors related to the use of the plugin.
"""


############################################################################################################
#################################### PIV DANTEC TECPLOT READER FUNCTION ####################################
############################################################################################################


def Reader_PIV_Dantec_Tecplot(filename, Folder_Path):
    
    fin = open(Folder_Path+"/"+filename, 'r')                                           #open the input file in read-only mode
    data = fin.read()                                                                   #read file contents to string
    
    if '"x (mm)[mm]"' in data:                                                          # Check if the input file have a typical header character of the Dantec Tecplot file. If that is the case, all the headers must be modified.

        data = data.replace('"x" "y" "x (mm)[mm]" "y (mm)[mm]" "U[m/s]" "V[m/s]" "W[m/s]"', 
        '"X,px" "Y,px" "X,mm" "Y,mm" "U,m_s" "V,m_s" "W,m_s"')    #replace the headers of the instantaneous PIV files
       
        data = data.replace('"x" "y" "x (mm)[mm]" "y (mm)[mm]" "U[m/s]" "V[m/s]" "W[m/s]" "Length[m/s]" "Status"', 
        '"X,px" "Y,px" "X,mm" "Y,mm" "U,m_s" "V,m_s" "W,m_s" "Length,m_s" "Status"')    #replace the headers of the instantaneous PIV files

        data = data.replace('"x" "y" "x (mm)[mm]" "y (mm)[mm]" "U[m/s]" "V[m/s]" "W[m/s]" "Std dev (U)[m/s]" "Std dev (V)[m/s]" "Std dev (W)[m/s]" "Sum(Var)[(m/s)²]" "Covar (U,V)[(m/s)²]" "Covar (U,W)[(m/s)²]" "Covar (V,W)[(m/s)²]" "Corr-coeff (U,V)" "Corr-coeff (U,W)" "Corr-coeff (V,W)" "Skew (U)" "Skew (V)" "Skew (W)" "Kurt (U)" "Kurt (V)" "Kurt (W)" "N[#]" "Length[m/s]" "Status"',
        '"X,px" "Y,px" "X,mm" "Y,mm" "U,m_s" "V,m_s" "W,m_s" "StdDevU,m_s" "StdDevV,m_s" "StdDevW,m_s" "SumVar,m2_s2" "CovarUV,m2_s2" "CovarUW,m2_s2" "CovarVW,m2_s2" "CorrCoeffUV" "CorrCoeffUW" "CorrCoeffVW" "SkewU" "SkewV" "SkewW" "KurtU" "KurtV" "KurtW" "N" "Length,m_s" "Status"')   #replace the headers of the mean PIV file

        print ("Reader_PIV_Dantec_Tecplot: headers modified in file --> ",filename )
        
    else:
        print ("Reader_PIV_Dantec_Tecplot: headers are already conformal (Or the variable 'x (mm)[mm]' was not found)", filename)
        

    fin.close()                                                                         #close the input file
    fin = open(Folder_Path+"/"+filename, "wt")                                          #open the input file in write mode
    fin.write(data)                                                                     #overrite the input file with the resulting data
    fin.close() 
    
