"""
############################################################################################################
#############################                     EPSILON                      #############################
#############################      Vectoflow 5HP calibration chart reader      #############################
############################################################################################################

# Abstract:
This python code is a module of the "Epsilon 5HP" plugin that reads data from a Vectoflow ".csv" file.
The output is a list with the headers and another list with the data (arranged in a matrix-shape).


# Disclaimer:
This plugin was developed for research purposes and released under GNU GPL V3 license without any guarantee
of any kind, either express or implied. Its use for teaching, research and industrial applications is allowed
under the strict responsibility of the user. The authors of this plugin are not responsible for any damages
or errors related to the use of the plugin.
"""


############################################################################################################
############################################### IMPORT MODULES #############################################
############################################################################################################

import os
import re
#import pandas as pd
#pd.core.format.header_style = None
import numpy as np



############################################################################################################
########################################### VECTOFLOW FILE PARSER ##########################################
############################################################################################################

def Reader_Vectoflow(filepath):                                           		                            # This creates an array containing only the interesting data from the Vectoflow file
	import numpy as np
	
	DATA = []                                                                                               # create an empty list to collect the data
	Headers = []                                                                                            # The header names are standarized during the file parsing
    
	with open(filepath, 'r') as file_object:                                                                # open the file and read through it line by line
		line = file_object.readline()                                                                       # It reads the first line of data

		while line:  
			line =  [name.strip() for name in line.split(';')]                 	                            # It splits line data where there is a space (tab) and also eliminates the spaces after or before each new splitted element. The result is a list of elements
			
			if str(line[0])=="Theta[deg]":                                         	                        # It detects the headers line
							
				line = [line.replace('Theta[deg]','Theta') for line in line]              				    # it replaces the variables names by a standard convention      
				line = [line.replace('Phi[deg]','Phi') for line in line]             
				line = [line.replace('Alpha[deg]','Alpha') for line in line]              
				line = [line.replace('Beta[deg]','Beta') for line in line]              
				line = [line.replace('P1[Pa] (Scanner P1)','P1') for line in line] 
				line = [line.replace('P2[Pa] (Scanner P2)','P2') for line in line] 
				line = [line.replace('P3[Pa] (Scanner P3)','P3') for line in line] 
				line = [line.replace('P4[Pa] (Scanner P4)','P4') for line in line] 
				line = [line.replace('P5[Pa] (Scanner P5)','P5') for line in line] 
				line = [line.replace('Pref[Pa]','Pref') for line in line] 
				line = [line.replace('Pt[Pa]','Pt') for line in line] 
				line = [line.replace('Ps[Abs,Pa]','Ps') for line in line] 
				line = [line.replace('Ts [C]','Ts') for line in line] 
				line = [line.replace('Ttot[C]','Tt') for line in line] 
				line = [line.replace('M[-]','M') for line in line] 
				line = [line.replace('Ttc [\xb0C]','Ttc') for line in line]                                 #\xb0 = degrees symbol
							
				Headers = line[:]            

				line = file_object.readline()                                 	                            # Goes to next line (where measurements start)

				while line.strip():                                          	                            # This keeps advancing until a blank line is found (end of measurement sampling)
					line = line.replace(',','.')                             	                            # It changes each comma by a dot
					line =  [name.strip() for name in line.split(';')]      	                            # It splits line data where there is a semicolon (;) and also eliminates the spaces after or before each new element.The result is a list of measurements.
					DATA.append(line[:])                                   		                            # It sends each line of data to the DATA output list                
					line = file_object.readline()                           	                            # It goes to the next line to keep advancing until the line with a blank line is found (end of data sampling)

					
			line = file_object.readline()                                                                   # Goes to the next line
					
	#DATA = np.asarray(DATA,dtype=np.float32)                                	                            # This converts a list into a numpy array
	#Headers = np.asarray(Headers)   

	
	return DATA, Headers

